      subroutine mtz_write_twin(
     &     nasym,hkl_asym,freer,weights_b,fcalc,npart_act,fpart,
     &     num_blocks,block_start,ref_2_asym_start,
     &     nobs,iobs,obs_start,
     &     ncomp,comp_numb,ref_2_asym,ref_2_symm,
     &     num_asym_ref,block_2_asym,fmax,hl_abcd,
     &     ierr)
      use weights
      use agreem
      use map_routines
      use restr_files
      implicit none
c
c---Initialise ml parameters
      include 'atom_com.fh'
      include 'celsym.fh'
      include 'twin_refmac.fh'
      include 'mtz_things.fh'
      include 'anom.fh'
c
      integer nasym,npart_act
      integer hkl_asym(3,nasym)
      real    fcalc(2,nasym),fpart(npart_act,2,nasym)
      integer num_blocks
      integer block_start(num_blocks+1),ref_2_asym_start(num_blocks+1)
      integer freer(num_blocks)
      real weights_b(num_blocks)
      integer nobs
      integer obs_start(nobs+1)
      real    iobs(2,nobs)
      integer ncomp
      integer comp_numb(ncomp),ref_2_asym(ncomp),ref_2_symm(ncomp)
      integer num_asym_ref
      integer block_2_asym(num_asym_ref)   
      real fmax(2,nasym)
      real hl_abcd(4,nasym)
      integer ierr
c
c
      integer nzero,nfree
c
c---mtz writing. move to another routine
      integer c_s,c_f,c_n,j
      real, allocatable :: fexpected(:,:)
      real, allocatable :: fomcalc(:)
      integer, allocatable :: asym_2_obs(:)
      integer, allocatable :: epsls(:)
      integer, allocatable :: centrs(:)
c
      real, allocatable :: rsq_ll(:),sigma_ll(:),fc_ll(:)
      real, allocatable :: aniso_scales(:)
c
      real a_all(2)
      real sc_p,ss
      real stl_c,rsq
      integer ip,ibin
      integer mtzout,iout,icell,iappnd,ib,i,i_inter
      integer, parameter :: bdata_num = 50
      real bdata(bdata_num)
      real a0,b0,a1,b1,f0,f1,ph0,ph1,scale_now,scale_p
      real auser,buser
      real pi,pisq8,rtodeg
      real lstlsq_r
      real fc_l,xx,cosp,sinp,sigma,sigma1
      real PHCOMB, HL(4), FOM
      integer ICENT
      external lstlsq_r
      integer labout_map(prgo)
      integer icol,isetid
      character dname_col(mcols)*64,xname_col(mcols)*64
c
c      real fsign(10000),fnoise(10000)
      integer nref_bin(10000)
      real b_median,filter,gsharp
      logical test_free
c
c---  body
c
      pi = 4.0*atan(1.0)
      pisq8 = 8.0*pi**2
      rtodeg = 180.0/pi
      allocate(fexpected(2,nasym))
      allocate(fomcalc(nasym))
      allocate(asym_2_obs(nasym))

      asym_2_obs(1:nasym) = -1
      do i=1,num_blocks
         c_s = ref_2_asym_start(i)+1
         c_f = ref_2_asym_start(i+1)
         do j=c_s,c_f
            c_n = block_2_asym(j)
            asym_2_obs(c_n) = i
         enddo
      enddo
c

      call find_fexpected_ml(
     &     nasym,hkl_asym,freer,weights_b,fcalc,npart_act,fpart,
     &     num_blocks,block_start,ref_2_asym_start,
     &     nobs,iobs,obs_start,
     &     ncomp,comp_numb,ref_2_asym,ref_2_symm,
     &     num_asym_ref,block_2_asym,fmax,hl_abcd,fexpected,fomcalc,
     &     ierr)
      allocate(epsls(nasym))
      allocate(centrs(nasym))
      call get_eps_centrs(
     &     nasym,hkl_asym,freer,weights_b,fcalc,npart_act,fpart,
     &     num_blocks,block_start,ref_2_asym_start,
     &     nobs,iobs,obs_start,
     &     ncomp,comp_numb,ref_2_asym,ref_2_symm,
     &     num_asym_ref,block_2_asym,
     &     epsls,centrs,
     &     ierr)

      allocate(aniso_scales(nasym))
      call aniso_contrs(nasym,hkl_asym,freer,weights_b,
     &     fcalc,npart_act,fpart,
     &     num_blocks,block_start,ref_2_asym_start,
     &     nobs,iobs,obs_start,
     &     ncomp,comp_numb,ref_2_asym,ref_2_symm,
     &     num_asym_ref,block_2_asym,
     &     aniso_scales,
     &     ierr)
c
c---test mtz
      MTZOUT = 2
      IAPPND = 0
      icent = 0
      call prepare_output(mtzout,labout_map,bdata_num)
      CALL LWOPEN(MTZOUT,'HKLOUT')
      CALL LWTITL(MTZOUT,'  Output mtz file from refmac',1)
      call lwassn(mtzout,lsprgo,nlprgo,ctprgo,iappnd)
      call lwclab(mtzout,lsprgo,nlprgo,ctprgo,iappnd)
      DO    ICELL=4,6
        IF(CELL(4).LE.5.0.AND.CELL(5).LE.5.0.AND.CELL(6).LE.5.0) THEN
          CELL(4) = CELL(4)*RTODEG
          CELL(5) = CELL(5)*RTODEG
          CELL(6) = CELL(6)*RTODEG
        ENDIF
      ENDDO
      CALL LWCELL(MTZOUT,CELL)
      CALL LWSORT(MTZOUT,ISORT)
C
      NumPrimSymm = NumSymmetry/NSMULT
C            ******************************
      CALL LWSYMM(MTZOUT,
     +                NumSymmetry,
     +                 NumPrimSymm,
     +                  RealSymmMatrx,
     +                   Ltype,
     +                    NumSpaceGroup,
     +                     SpaceGroupName,
     +                      PointGroupName)
      CALL LWASSN(MTZOUT,LSPRGO,NLPRGO,CTPRGO,IAPPND)

C Store the project name and dataset name in the mtz header:
      IF (NDATASETS_out.GT.0) THEN
        DO ISET = 1,NDATASETS_out
           CALL LWIDX(MTZOUT,PNAME_out(ISET),XNAME_out(ISET),
     +          DNAME_out(ISET),DATCELL_out(1,ISET),DATWAVE_out(ISET))
        ENDDO
        do icol=1,nlprgo
           isetid = csetout(icol)+1
           xname_col(icol) = xname_out(isetid)
           dname_col(icol) = dname_out(isetid)
        enddo
        CALL LWIDASX(MTZOUT,NLPRGO,XNAME_col,DNAME_col,IAPPND)
      ENDIF
c
      i_inter = -1
      if(sharp_map_flag.and.b_sharp_map.le.0.0) then
         call calc_bmedian(b_median)
         b_sharp_map = b_median*pisq8
         write(*,*)'Median of atomic b values',b_sharp_map
      endif
      if(sharp_map_flag.and.sharp_regul_opt) then
         allocate(rsq_ll(nasym))
         allocate(sigma_ll(nasym))
         allocate(fc_ll(nasym))
         do i=1,nasym
            ss = lstlsq_r(1,hkl_asym(1:3,i))
            rsq_ll(i) = 4.0*ss
            stl_c = sqrt(rsq_ll(i))
            call linter_value2(nbin_ml,smeanb_ml,sigma_ml,stl_c,
     &           i_inter,sigma)
            sigma_ll(i) = sigma*epsls(i)*(1+centrs(i))

            call linter_value2(nbin_ml,smeanb_ml,scale_ml(1,1),
     &           stl_c,i_inter,scale_now)            
            scale_p = scale_now
            a_all(1) = scale_now*fcalc(1,i)
            a_all(2) = scale_now*fcalc(2,i)
            sc_p  = scale_ls_over*exp(-b_ls_over*ss)*
     &           (1.0-scale_ls_bulk*exp(-b_ls_bulk*ss))
            sc_p = sqrt(sc_p)*scale_ml(ibin,1)
            do ip=1,npart_act
               call linter_value2(nbin_ml,smeanb_ml,scale_ml(1,ip+1),
     &              stl_c,i_inter,scale_now)
               a_all(1)=a_all(1)+scale_now*fpart(ip,1,i)
               a_all(2)=a_all(2)+scale_now*fpart(ip,2,i)
            enddo
            fc_ll(i) = sqrt(a_all(1)**2+a_all(2)**2)
         enddo
         call ts_filter_params_setup(
     &        fmax(1,1:nasym),fmax(2,1:nasym),
     &        fc_ll(1:nasym),fomcalc(1:nasym),sigma_ll(1:nasym),
     &        rsq_ll(1:nasym),aniso_scales)

c
c---Deallocate these arrays
         deallocate(rsq_ll)
         deallocate(sigma_ll)
         deallocate(fc_ll)
      endif

      if(sharp_map_flag) then
         call header('Filter parameters')
         write(*,*)' Regularisation parameter (alpha) : ',
     &        alpha_sharp_map
         write(*,*)' B value for map sharpening       : ',
     &        b_sharp_map
         write(*,*)' Regularisation degrees of freedom: ',
     &        fraction_sharp_map
         write(*,*)
         write(*,*)
         write(*,*)' If regulatisation parameter defined by',
     &        ' user then degrees of freedom is irrelevant'
         write(*,'(2x,80a)')('-',i=1,80)

      endif

c
      do i=1,nasym
         CALL EQUAL_MAGIC(MTZOUT,BDATA,nlprgo)
         labouts(labout_map(1:nlprgo))%val = bdata(1:nlprgo)
c
c---  hkl
         labouts(1:3)%val = hkl_asym(1:3,i)
c
c---  FreeR set
         if(asym_2_obs(i).gt.0) then
            if (oc_FREE%use) oc_FREE%val = freer(asym_2_obs(i))
         else
            if (oc_FREE%use) oc_FREE%val = 0            
         endif
         rsq = 4.0*lstlsq_r(1,hkl_asym(1:3,i))
         if(b_sharp_map.gt.0.0) then
                                !  
                                !  Consider various options
            call ts_weight_calc(rsq,aniso_scales(i),filter)
         else
            filter = 1.0
         endif

         stl_c = sqrt(rsq)
         do ib=1,nbin_ml
            if(stl_c.ge.sminb_ml(ib).and.stl_c.le.smaxb_ml(ib))
     &           then
               ibin = ib
               goto 50
            endif
         enddo
         if(stl_c.ge.smaxb_ml(nbin_ml))ibin = nbin_ml
         if(stl_c.le.sminb_ml(1)) ibin = 1
 50      continue
         if (oc_FC%use.and.oc_PHIC%use) then
            oc_FC%val = sqrt(fcalc(1,i)**2+fcalc(2,i)**2)
            oc_PHIC%val = rtodeg*atan2(fcalc(2,i),fcalc(1,i))
         endif
c
         call linter_value2(nbin_ml,smeanb_ml,scale_ml(1,1),
     &        stl_c,i_inter,scale_now)
         call linter_value2(nbin_ml,smeanb_ml,sigma_ml,stl_c,
     &        i_inter,sigma)
         scale_p = scale_now
         if(mapc_remove_dpar) filter = filter/scale_p
         a_all(1) = scale_now*fcalc(1,i)
         a_all(2) = scale_now*fcalc(2,i)
         ss = lstlsq_r(1,hkl_asym(1:3,i))
         sc_p  = scale_ls_over*exp(-b_ls_over*ss)*
     &        (1.0-scale_ls_bulk*exp(-b_ls_bulk*ss))
         sc_p = sqrt(sc_p)*scale_ml(ibin,1)
         do ip=1,npart_act
            call linter_value2(nbin_ml,smeanb_ml,scale_ml(1,ip+1),
     &           stl_c,i_inter,scale_now)
            a_all(1)=a_all(1)+scale_now*fpart(ip,1,i)
            a_all(2)=a_all(2)+scale_now*fpart(ip,2,i)
         enddo
c
c---Should we multiply by sc_p?
         if (oc_FC_ALL%use.and.oc_PHIC_ALL%use) then
            oc_FC_ALL%val = sqrt(a_all(1)**2+a_all(2)**2)
            oc_PHIC_ALL%val = rtodeg*atan2(a_all(2),a_all(1))
            phcomb = oc_PHIC_ALL%val
         endif
         cosp = 0.0
         sinp = 0.0
         fc_l = sqrt(a_all(1)**2+a_all(2)**2)
         xx = 0.0
         if(fc_l.gt.0.0) then
            cosp = a_all(1)/fc_l
            sinp = a_all(2)/fc_l
            sigma1 = sigma*epsls(i)*(1+centrs(i))
     &           + 2.0*fmax(2,i)**2
            xx = 2.0*fmax(1,i)*fc_l/sigma1
         endif
         hl(1) = hl_abcd(1,i) + cosp*xx
         hl(2) = hl_abcd(2,i) + sinp*xx
         hl(3) = hl_abcd(3,i)
         hl(4) = hl_abcd(4,i)         
c
c---Observation exists

         if(asym_2_obs(i).gt.0) then
            if (oc_FP%use) oc_FP%val = fmax(1,i)
            if (oc_SIGFP%use) oc_SIGFP%val = fmax(2,i)
c            write(20,*)fmax(1,i), sqrt(a_all(1)**2+a_all(2)**2)
         endif
         if (oc_FOM%use) then 
            FOM = fomcalc(i)
            oc_FOM%val = FOM
         endif
c     if(oc_FOM%use) oc_FOM%val = 0.0
         if(oc_PHCOMB%use) then
            PHCOMB = atan2(a_all(2),a_all(1))
            oc_PHCOMB%val = rtodeg*PHCOMB
         endif
         if (oc_HLACOMB%use.and.oc_HLBCOMB%use) then
            oc_HLACOMB%val = HL(1)
            oc_HLBCOMB%val = HL(2)
            oc_HLCCOMB%val = hl(3)
            oc_HLDCOMB%val = hl(4)
         endif
         test_free = .FALSE.
         if(asym_2_obs(i).gt.0) then
            if(fmax(1,i).gt.0.0.and.freer(asym_2_obs(i)).gt.0.or.
     &           free_for_map.eq.'I') test_free = .TRUE.
         endif
         if (test_free) then          

            a0 = fexpected(1,i)-a_all(1)
            b0 = fexpected(2,i)-a_all(2)
            f0 = sqrt(a0**2+b0**2)
            ph0 = rtodeg*atan2(b0,a0)
            a1 = 2.0*a0 + a_all(1)
            b1 = 2.0*b0 + a_all(2)
            f1 = sqrt(a1**2+b1**2)
            ph1 = rtodeg*atan2(b1,a1)
            if (oc_FWT%use.and.oc_PHWT%use) then
              oc_FWT%val = f1*filter
              oc_PHWT%val = ph1
            endif

            if (oc_DELFWT%use.and.oc_PHDELWT%use) then
              oc_DELFWT%val = f0*filter
              oc_PHDELWT%val = ph0
            endif

            if(oc_F_user%use.or.oc_phi_user%use) then
              auser       = scale_map_obs*fexpected(1,i) - 
     &                              scale_map_calc*a_all(1)
              buser       = scale_map_obs*fexpected(2,i) - 
     &                              scale_map_calc*a_all(2)
              oc_f_user%val = sqrt(auser**2+buser**2)*filter
              oc_phi_user%val = 0.0
              if (oc_f_user%val.gt.0.0) then
                oc_phi_user%val = rtodeg*ATAN2(buser,auser)
                if (oc_f_user%val.lt.0.0) 
     &              oc_phi_user%val = oc_phi_user%val + 360.0
              endif
            endif
         else if(free_for_map.eq.'R') then
           if (oc_FREE%use) oc_FREE%val = 0
            if(oc_FWT%use.and.oc_PHDELWT%use) then
               oc_FWT%val = sqrt(a_all(1)**2+a_all(2)**2)
               oc_FWT%val = oc_FWT%val*filter
               oc_PHWT%val = 0.0
               if(oc_FWT%val .gt. 0.0) 
     &              oc_PHWT%val=rtodeg*atan2(a_all(2),a_all(1))
            endif
            if(oc_DELFWT%use.and.oc_PHDELWT%use) then
               oc_DELFWT%val = 0.0
               oc_PHDELWT%val = 0.0
            endif

            if (oc_f_user%use.or.oc_phi_user%use) then
               oc_f_user%val = sqrt(a_all(1)**2+a_all(2)**2)
               oc_f_user%val = oc_f_user%val*filter
               oc_phi_user%val = 0.0
               if(oc_f_user%val.gt.0.0) 
     &              oc_phi_user%val = rtodeg*atan2(a_all(2),a_all(1))
            endif
         endif
         call make_BDATA_OUT(BDATA,bdata_num,labout_map)
         call lwrefl(mtzout,bdata)
      enddo
      call lwclos(mtzout,0)

      deallocate(epsls)
      deallocate(centrs)      
      deallocate(fexpected)
      deallocate(fomcalc)
      deallocate(asym_2_obs)
      deallocate(aniso_scales)
      return
      end
c
      subroutine reflection_write_rand(
     &     nasym,hkl_asym,freer,weights_b,fcalc,npart_act,fpart,
     &     num_blocks,block_start,ref_2_asym_start,
     &     nobs,iobs,obs_start,
     &     ncomp,comp_numb,ref_2_asym,ref_2_symm,
     &     num_asym_ref,block_2_asym,fmax,hl_abcd,
     &     ierr)
      use weights
      use agreem
      use map_routines
      use restr_files
      implicit none
c
c---Initialise ml parameters
      include 'atom_com.fh'
      include 'celsym.fh'
      include 'twin_refmac.fh'
      include 'mtz_things.fh'
      include 'anom.fh'
c
      integer nasym,npart_act
      integer hkl_asym(3,nasym)
      real    fcalc(2,nasym),fpart(npart_act,2,nasym)
      integer num_blocks
      integer block_start(num_blocks+1),ref_2_asym_start(num_blocks+1)
      integer freer(num_blocks)
      real weights_b(num_blocks)
      integer nobs
      integer obs_start(nobs+1)
      real    iobs(2,nobs)
      integer ncomp
      integer comp_numb(ncomp),ref_2_asym(ncomp),ref_2_symm(ncomp)
      integer num_asym_ref
      integer block_2_asym(num_asym_ref)   
      real fmax(2,nasym)
      real hl_abcd(4,nasym)
      integer ierr
c
c
      integer nzero,nfree
c
c---mtz writing. move to another routine
      integer c_s,c_f,c_n,j
      real, allocatable :: fexpected(:,:)
      real, allocatable :: fomcalc(:)
      integer, allocatable :: asym_2_obs(:)
c
      real a_all(2),a_all0(2)
      real sc_p,ss
      real stl_c,rsq
      integer ip,ibin
      integer mtzout,iout,icell,iappnd,ib,i,i_inter
      integer, parameter :: bdata_num = 50
      real bdata(bdata_num)
      real a0,b0,a1,b1,f0,f1,ph0,ph1,scale_now
      real auser,buser
      real rtodeg
      real lstlsq_r
      real PHCOMB, HL(4), FOM
      integer ICENT
      external lstlsq_r
      integer labout_map(prgo)
      integer icol,isetid
      character dname_col(mcols)*64,xname_col(mcols)*64
c
      logical test_free
c
      integer ofile_int
      real free_now,fp_now,sigfp_now,weight_now
      real fc_now,phic_now,fwt_now,phwt_now,delfwt_now,phdelwt_now
      real fc_all,phic_all,fc_all0,phic_all0,fom_now,sharp_now
c
c---  body
c

      rtodeg = 45.0/atan2(1.0,1.0)
      allocate(fexpected(2,nasym))
      allocate(fomcalc(nasym))
      allocate(asym_2_obs(nasym))

      asym_2_obs(1:nasym) = -1
      do i=1,num_blocks
         c_s = ref_2_asym_start(i)+1
         c_f = ref_2_asym_start(i+1)
         do j=c_s,c_f
            c_n = block_2_asym(j)
            asym_2_obs(c_n) = i
         enddo
      enddo

c
      call find_fexpected_ml(
     &     nasym,hkl_asym,freer,weights_b,fcalc,npart_act,fpart,
     &     num_blocks,block_start,ref_2_asym_start,
     &     nobs,iobs,obs_start,
     &     ncomp,comp_numb,ref_2_asym,ref_2_symm,
     &     num_asym_ref,block_2_asym,fmax,hl_abcd,fexpected,fomcalc,
     &     ierr)

c
      call open_unform_file(ofile_int,'INT_REFL_FILE',ierr)

      write(ofile_int)nasym

      i_inter = -1
      do i=1,nasym
c
c---  FreeR set
         if(asym_2_obs(i).gt.0) then
            weight_now = weights_b(asym_2_obs(i))
         else
            weight_now = 0.0
         endif
         rsq = 4.0*lstlsq_r(1,hkl_asym(1:3,i))
         stl_c = sqrt(rsq)
         sharp_now = exp(b_sharp_map*rsq/4.0)
         do ib=1,nbin_ml
            if(stl_c.ge.sminb_ml(ib).and.stl_c.le.smaxb_ml(ib))
     &           then
               ibin = ib
               goto 50
            endif
         enddo
         if(stl_c.ge.smaxb_ml(nbin_ml))ibin = nbin_ml
         if(stl_c.le.sminb_ml(1)) ibin = 1
 50      continue
         fc_now = sqrt(fcalc(1,i)**2+fcalc(2,i)**2)*sharp_now
         phic_now = rtodeg*atan2(fcalc(2,i),fcalc(1,i))
c
         call linter_value2(nbin_ml,smeanb_ml,scale_ml(1,1),
     &        stl_c,i_inter,scale_now)
         a_all0(1:2) = fcalc(1:2,i)
         a_all(1) = scale_now*fcalc(1,i)
         a_all(2) = scale_now*fcalc(2,i)
         ss = lstlsq_r(1,hkl_asym(1:3,i))
         sc_p  = scale_ls_over*exp(-b_ls_over*ss)*
     &        (1.0-scale_ls_bulk*exp(-b_ls_bulk*ss))
         sc_p = sqrt(sc_p)*scale_ml(ibin,1)
         do ip=1,npart_act
            call linter_value2(nbin_ml,smeanb_ml,scale_ml(1,ip+1),
     &           stl_c,i_inter,scale_now)
            a_all0(1:2) = a_all0(1:2) + fpart(ip,1:2,i)
            a_all(1)=a_all(1)+scale_now*fpart(ip,1,i)
            a_all(2)=a_all(2)+scale_now*fpart(ip,2,i)
         enddo
         fc_all = sqrt(a_all(1)**2+a_all(2)**2)*sharp_now
         phic_all = rtodeg*atan2(a_all(2),a_all(1))
         fc_all0 = sqrt(a_all0(1)**2+a_all0(2)**2)*sharp_now
         phic_all0 = rtodeg*atan2(a_all0(2),a_all0(1))
c
c---Observation exists
         test_free = .FALSE.
         if(asym_2_obs(i).gt.0) then
            if(fmax(1,i).gt.0.0.and.freer(asym_2_obs(i)).gt.0.or.
     &           free_for_map.eq.'I') test_free = .TRUE.
         endif
         fp_now = 0.0
         sigfp_now = 0.0
         if(asym_2_obs(i).gt.0) then
            fp_now = fmax(1,i)*sharp_now
            sigfp_now = fmax(2,i)*sharp_now
         endif
         if (test_free) then          
c            free_now = freer(asym_2_obs(i))

            a0 = fexpected(1,i)-a_all(1)
            b0 = fexpected(2,i)-a_all(2)
            f0 = sqrt(a0**2+b0**2)*sharp_now
            ph0 = rtodeg*atan2(b0,a0)
            a1 = 2.0*a0 + a_all(1)
            b1 = 2.0*b0 + a_all(2)
            f1 = sqrt(a1**2+b1**2)*sharp_now
            ph1 = rtodeg*atan2(b1,a1)
            fwt_now = f1
            phwt_now = ph1
            delfwt_now = f0
            phdelwt_now =ph0
            fom_now = fomcalc(i)
         else if(free_for_map.eq.'R') then
c           if (oc_FREE%use) oc_FREE%val = 0
            fwt_now = sqrt(a_all(1)**2+a_all(2)**2)
            fwt_now = fwt_now*sharp_now
            phwt_now = rtodeg*atan2(a_all(2),a_all(1))
            delfwt_now = 0.0
            phdelwt_now = 0.0
            fom_now = fomcalc(i)
         endif
         write(ofile_int)hkl_asym(1:3,i),free_now,weight_now,
     &        fp_now,sigfp_now,
     &        fc_now,phic_now,fc_all0,phic_all0,fwt_now,phwt_now,
     &        delfwt_now,phdelwt_now
      enddo
      close(ofile_int)
      deallocate(fexpected)
      deallocate(fomcalc)
      deallocate(asym_2_obs)
      return
      end
c
      subroutine mtz_write_acc(
     &     nasym,hkl_asym,freer,fobs,fcalc,fcall,fwt,delfwt)
      use weights
      use agreem
      use map_routines
      use restr_files
      implicit none
c
c---Initialise ml parameters
      include 'atom_com.fh'
      include 'celsym.fh'
      include 'twin_refmac.fh'
      include 'mtz_things.fh'
      include 'anom.fh'
c
      integer nasym,npart_act
      integer hkl_asym(3,nasym)
      real    fcalc(2,nasym),fcall(2,nasym),fobs(2,nasym)
      real    fwt(2,nasym),delfwt(2,nasym)
      real    freer(nasym)
      integer ierr
c
      integer nzero,nfree
c

      integer mtzout,iout,icell,iappnd,ib,i,i_inter
      integer, parameter :: bdata_num = 50
      real bdata(bdata_num)
      real rtodeg
      integer labout_map(prgo)
      integer icol,isetid
      character dname_col(mcols)*64,xname_col(mcols)*64
c
c---  body
c
      rtodeg = 45.0/atan2(1.0,1.0)

c---test mtz
      MTZOUT = 2
      IAPPND = 0
      call prepare_output(mtzout,labout_map,bdata_num)
      CALL LWOPEN(MTZOUT,'HKLOUT')
      CALL LWTITL(MTZOUT,'  Output mtz file from refmac',1)
      call lwassn(mtzout,lsprgo,nlprgo,ctprgo,iappnd)
      call lwclab(mtzout,lsprgo,nlprgo,ctprgo,iappnd)
      DO    ICELL=4,6
        IF(CELL(4).LE.5.0.AND.CELL(5).LE.5.0.AND.CELL(6).LE.5.0) THEN
          CELL(4) = CELL(4)*RTODEG
          CELL(5) = CELL(5)*RTODEG
          CELL(6) = CELL(6)*RTODEG
        ENDIF
      ENDDO
      CALL LWCELL(MTZOUT,CELL)
      CALL LWSORT(MTZOUT,ISORT)
C
      NumPrimSymm = NumSymmetry/NSMULT
C            ******************************
      CALL LWSYMM(MTZOUT,
     +                NumSymmetry,
     +                 NumPrimSymm,
     +                  RealSymmMatrx,
     +                   Ltype,
     +                    NumSpaceGroup,
     +                     SpaceGroupName,
     +                      PointGroupName)
      CALL LWASSN(MTZOUT,LSPRGO,NLPRGO,CTPRGO,IAPPND)

C Store the project name and dataset name in the mtz header:
      IF (NDATASETS_out.GT.0) THEN
        DO ISET = 1,NDATASETS_out
           CALL LWIDX(MTZOUT,PNAME_out(ISET),XNAME_out(ISET),
     +          DNAME_out(ISET),DATCELL_out(1,ISET),DATWAVE_out(ISET))
        ENDDO
        do icol=1,nlprgo
           isetid = csetout(icol)+1
           xname_col(icol) = xname_out(isetid)
           dname_col(icol) = dname_out(isetid)
        enddo
        CALL LWIDASX(MTZOUT,NLPRGO,XNAME_col,DNAME_col,IAPPND)
      ENDIF
c
      do i=1,nasym
         CALL EQUAL_MAGIC(MTZOUT,BDATA,nlprgo)
         labouts(labout_map(1:nlprgo))%val = bdata(1:nlprgo)
         labouts(1:3)%val = hkl_asym(1:3,i)
         oc_FP%val = fobs(1,i)
         oc_SIGFP%val = fobs(2,i)
         oc_FREE%val = freer(i)
         oc_FC%val = sqrt(fcalc(1,i)**2+fcalc(2,i)**2)
         oc_PHIC%val = atan2(fcalc(2,i),fcalc(1,i))*rtodeg
         oc_FC_ALL%val = sqrt(fcall(1,i)**2+fcall(2,i)**2)
         oc_PHIC_ALL%val = atan2(fcall(2,i),fcall(1,i))*rtodeg
         oc_FWT%val = sqrt(fwt(1,i)**2+fwt(2,i)**2)
         oc_PHWT%val = atan2(fwt(2,i),fwt(1,i))*rtodeg
         oc_DELFWT%val = sqrt(delfwt(1,i)**2+delfwt(2,i)**2)
         oc_PHDELWT%val = atan2(delfwt(2,i),delfwt(1,i))*rtodeg
         oc_FOM%val = 1.0

         call make_BDATA_OUT(BDATA,bdata_num,labout_map)
         call lwrefl(mtzout,bdata)
      enddo
      call lwclos(mtzout,0)
 
      return
      end
c
      subroutine mtz_write_extend(nasym,nout,labels,ltypes,
     &     hkl_asym,fall_in,file_name)
      use weights
      use agreem
      use map_routines
      use restr_files
      implicit none
c
c---Initialise ml parameters
      include 'atom_com.fh'
      include 'celsym.fh'
      include 'twin_refmac.fh'
      include 'anom.fh'
c
      integer nout
      integer nasym,npart_act
      integer hkl_asym(3,nasym)
      real    fall_in(nout,nasym)
      character file_name*(*)
      character labels(nout)*(*),ltypes(nout)*(*)
      integer ierr
c
      integer nzero,nfree
c
      integer mtzout,iout,icell,iappnd,ib,i,j,nlprgo
      integer, parameter :: bdata_num = 50
      real bdata(bdata_num)
      real rtodeg
      integer icol,isetid

      real f0,phi
      character*1 ctprgo(bdata_num)
      character*16 lsprgo(bdata_num)

      real rsq
      real lstlsq
c
c---  body
c
      rtodeg = 45.0/atan2(1.0,1.0)

c---test mtz
      MTZOUT = 3
      IAPPND = 0
      CALL LWOPEN(MTZOUT,file_name)
      CALL LWTITL(MTZOUT,
     &     '  Output mtz file from refmac: Resolution extendd',1)
      lsprgo(1) = 'H'
      ctprgo(1) = 'H'
      lsprgo(2) = 'K'
      ctprgo(2) = 'H'
      lsprgo(3) = 'L'
      ctprgo(3) = 'H'
      do i=1,nout
         lsprgo(3+i) = trim(labels(i))
         ctprgo(3+i) = trim(ltypes(i))
      enddo

      nlprgo = 3+nout
      write(*,*)labels
      write(*,*)ltypes
      call lwassn(mtzout,lsprgo,nlprgo,ctprgo,iappnd)
      call lwclab(mtzout,lsprgo,nlprgo,ctprgo,iappnd)
      DO    ICELL=4,6
        IF(CELL(4).LE.5.0.AND.CELL(5).LE.5.0.AND.CELL(6).LE.5.0) THEN
          CELL(4) = CELL(4)*RTODEG
          CELL(5) = CELL(5)*RTODEG
          CELL(6) = CELL(6)*RTODEG
        ENDIF
      ENDDO
      CALL LWCELL(MTZOUT,CELL)
      CALL LWSORT(MTZOUT,ISORT)
C
      NumPrimSymm = NumSymmetry/NSMULT
C            ******************************
      CALL LWSYMM(MTZOUT,
     +                NumSymmetry,
     +                 NumPrimSymm,
     +                  RealSymmMatrx,
     +                   Ltype,
     +                    NumSpaceGroup,
     +                     SpaceGroupName,
     +                      PointGroupName)
      CALL LWASSN(MTZOUT,LSPRGO,NLPRGO,CTPRGO,IAPPND)
c
      open(66)
      write(*,*)ltypes
      do i=1,nasym
         call equal_magic(mtzout,bdata,nlprgo)
         bdata(1:3) = float(hkl_asym(1:3,i))
         j=1
         do while(j.le.nout)
            if(j.lt.nout) then
               if(ltypes(j+1).eq.'Q') then
                  if(fall_in(j+1,i).gt.0.0) then
                     bdata(3+j) = fall_in(j,i)
                     bdata(3+j+1) = fall_in(j,i)
                  endif
                  j = j +2
               else
                  bdata(3+j)  = fall_in(j,i)
                  j = j + 1
               endif
            else
               bdata(3+j)  = fall_in(j,i)
               j = j + 1
            endif               
         enddo
         write(66,*)bdata(1:nout+3)
         call lwrefl(mtzout,bdata)
      enddo
      call lwclos(mtzout,0)
      close(66)
      return
      end
